# Mandala aus Vielecken
# Name: Mandala.py

from turtle import*
shape ("turtle")
speed(0) # höchste Geschwindigkeit
width(2) # mitteldicke Linie

# Funktionen für verschiedene Figuren für Mandalas

def Raute(Schritte):   
  for i in range(2):
    forward(Schritte)
    left(60)  #36
    forward(Schritte)
    left(120) #144
  
def Kreis(Schritte):
  for i in range (60):
    forward(Schritte)
    right(6)

def Vieleck(Schritte, Ecken):
  Winkel = 360/Ecken
  for i in range(Ecken):
    forward(Schritte)
    left(Winkel)

def Vieleckblume(Ecken,Anzahl_pro_Runde):
  # Male kleine Sechsecke, im Kreis angeordnet
  color("red")
  for i in range(Anzahl_pro_Runde):
      Vieleck(60,Ecken)
      left(360/Anzahl_pro_Runde)
   
  # Male mittlere Sechsecke, im Kreis angeordnet
  color("green")
  for i in range(Anzahl_pro_Runde):
      Vieleck(120,Ecken)
      left(360/Anzahl_pro_Runde)

  # Male große Sechsecke, im Kreis angeordnet
  color("blue")
  for i in range(Anzahl_pro_Runde):
      Vieleck(180,Ecken)
      left(360/Anzahl_pro_Runde)

###### PROGRAMME (Entferne Kommentarzeichen vor einer Zeile): 

## Dreieck-Blumen
# Vieleckblume(3,3)
# Vieleckblume(3,24)

## Sechseck-Blumen:
#Vieleckblume(6,6)
#Vieleckblume(6,12)
#Vieleckblume(6,24)

## Achteck-Blumen
Vieleckblume(8,12)


exitonclick()


