# Fünfzackiger Stern in zwei Varianten
# Name: Fuenfzackenstern.py

from turtle import *
shape("turtle")
speed(2)
width(2)

# Hier geht die Schildkröte am Zackenrand entlang
def Fuenfzackenstern(Schritte, Farbe):
        color(Farbe)
        begin_fill()
        for i in range(5):
                forward(Schritte)
                right(144)
                forward(Schritte)
                left(72)
        end_fill()
             
# Hier der Fünfstern aus 5 kreuzenden Linien gemalt
def Fuenfzackenstern_mit_Fuenfeck(Schritte,Farbe):
        color(Farbe)
        begin_fill()
        for _ in range(5):
                forward(Schritte)
                right(144)
        end_fill()

## Erklärung des Drehwinkels 144 Grad an der Zackenspitze:
## - Fünfeck, wo auf jeder Seite ein gleichschenkliges Dreieck thront
## - Die beiden gleichen Dreieckswinkel entsprechen dem Drehwinkel vom Fünfeck
##        - Das sind 360/5 = 72 Grad
## - Damit ist der spitze Winkel 180 - (2*72) = 36 Grad
## - Damit ist der Drehwinkel der Schildkröte 180-36 = 144 Grad
##        - Also in einer Rechnung: 180 - (180 - (2* 360/5)) = 144

        
# Programm beginnt --------------------------------------

Fuenfzackenstern(200,"gold")
Fuenfzackenstern_mit_Fuenfeck(100,"red")

exitonclick()
