# Spiralenprogramme
# Name: Spiralen.py

from random import *
from turtle import *

shape("turtle")
speed(0)
width(6)

# Quadrat
def Quadrat(Schritte):
    for i in range(4):
        forward(Schritte)
        right(90)
        
# Zum Vergleich unsere Kreisfunktion:
def Kreis(Schritte):
    for i in range(50):
        forward(Schritte)
        right(360/50)

def Spirale_zehnfach():
    for i in range(500):
        forward(5+i/16)
        right(360/50)

def Strudel():
    w=1
    for i in range(350):
        forward(3+i/16)
        width(w+i/16)
        right(360/50)

def Spirale_von_grün_nach_rot():
    blau=0
    for i in range (300):
        rot = i/300
        grün = 1 - i/300
        color(rot, grün, blau)
        forward(3 + i/16)
        right(360/50)
    
def Strudel_von_rot_nach_blau():
    grün=0
    w=1
    for i in range (300):
        blau = i/300
        rot = 1 - i/300
        color(rot, grün, blau)
        width(w+i/16)
        forward(3 + i/16)
        right(360/50)

def Strudel_mit_Zufallsfarben():
    w=1
    for i in range (300):
        rot = random()
        grün = random()
        blau = random()
        color(rot, grün, blau)
        width(w+i/16)
        forward(3 + i/16)
        right(360/50)

def Fünfzackenstern(Zackenlänge): # brauchen wir für Sternenspirale()
        color("yellow")
        begin_fill()
        for i in range(5):
            forward(Zackenlänge)
            right(2 * 360/5)
        end_fill()
        
def Sternenspirale():
    # dunkelblaues Himmelsquadrat als Hintergrund
    setpos(-150,150)
    color("darkblue") 
    begin_fill()
    Quadrat(400)
    end_fill()    
    right(90)
    penup()
    # Gehe ins Innere des Himmelsquadrats
    forward(130) 
    left(90)
    forward(210)
    # Male die Sternenspirale
    w=1
    for i in range(200): 
        width(w+i/100)          # Strichdicke wächst mit i
        Fünfzackenstern(6+i/16) # Zackenlänge wächst mit i
        penup() 
        forward(10+i/16)        # Spirale öffnet sich mit i
        pendown()
        right(360/50)

def Fünfzackenstern_bunt(Zackenlänge): # brauchen wir für Sternenspirale_bunteSterne()
        rot = random()
        grün = random()
        blau = random()
        color(rot, grün, blau)
        begin_fill()
        for i in range(5):
            forward(Zackenlänge)
            right(2 * 360/5)
        end_fill()
        
def Sternenspirale_bunteSterne():
    w=1
    for i in range(200): 
        width(w+i/100)               # Strichdicke wächst mit i
        Fünfzackenstern_bunt(6+i/16) # Zackengröße wächst mit i
        penup()
        forward(10+i/16)             # Spirale öffnet sich mit i
        pendown()
        right(360/50)   


# Programm beginnt

#Spiralenprogramme: einfach eine Funktion aufrufen
##################################################
   
#Spirale_zehnfach()
#Strudel()
#Spirale_von_grün_nach_rot()
#Strudel_von_rot_nach_blau()
#Strudel_mit_Zufallsfarben()
Sternenspirale()
#Sternenspirale_bunteSterne()

exitonclick()



