# Drachenkurve.py
# zeichnet Drachenkurven unterschiedlicher Rekursionsstufen
# - Vertikale Strecken werden rechtwinklig nach rechts gekippt
# - Horizontale Strecken werden rechtwinklig nach links gekippt

from turtle import *

shape("turtle")
tracer(100)
width(1)

def StreckeVertikal(Strecke, RT):
    if (RT == 0):
        forward(Strecke)  #Rekursionsabbruch
    else:
        StreckeVertikal(Strecke/2, RT-1)
        right(90)
        StreckeHorizontal(Strecke/2, RT-1)

def StreckeHorizontal(Strecke, RT):
    if (RT == 0):
        forward(Strecke)  #Rekursionsabbruch
    else:
        StreckeVertikal(Strecke/2, RT-1)
        left(90)
        StreckeHorizontal(Strecke/2, RT-1)
        
############## PROGRAMM  ###################
        
left(90) # Richtung nach oben
#StreckeVertikal(4000, 9)
StreckeVertikal(40000, 14)
#StreckeVertikal(40000, 15)

exitonclick()


