# Unterschiedliche verschachtelte Figuren mit Rekursion
# Name: Schachtelfiguren.py

from turtle import *
from random import *

shape("turtle")
speed(0)


### HILFSFIGUREN

def Quadrat(Seitenlänge):
  color(random(),random(),random())
  begin_fill()
  for i in range(4):
    forward(Seitenlänge)
    right(90)
  end_fill()
  

def Vieleck(Ecken,Seitenlänge):
  color(random(),random(),random())
  begin_fill()
  for i in range (Ecken):
    forward(Seitenlänge)
    right(360/Ecken)
  end_fill()
  

def Ellipse(Schritte):
  color(random(),random(),random())
  begin_fill()
  for i in range(2):
        for i in range (60):
          forward(Schritte/2)
          right(1) # Weiter Kreisbogen 
        for i in range (60):
          forward(Schritte/2)
          right(2) # Enger Kreisbogen
  end_fill()
  

def Fünfzackenstern(Schritte):
        color(random(),random(),random())
        begin_fill()
        for i in range(5):
          forward(Schritte)
          right(2 * 360/5)
        end_fill()


### SCHACHTELFIGUREN 
  
def Schachtelquadrat(Seitenlänge):
  # 1. Male das aktuelle Quadrat
  Quadrat(Seitenlänge)
  # 2. Nimm Position für das nächstinnere Quadrat ein
  penup()
  forward(10)
  right(90)
  forward(10)
  left(90)
  pendown()
  # Enthält das aktuelle Quadrat noch weitere Schachtelquadrate?
  if Seitenlänge-20 > 20:
  # 3. Falls ja: Weitermachen mit nächstkleinerem Schachtelquadrat
    Schachtelquadrat(Seitenlänge - 20)
  # 4. Falls nicht: Aufhören mit einem einfachen Quadrat
  else:
    Quadrat(Seitenlänge - 20)
    

def Schachteldreieck(Seitenlänge):
  # 1. Male das äußerste Dreieck
  Vieleck(3,Seitenlänge)
  # 2. Nimm Position für das nächstinnere Dreieck ein
  penup()
  forward(10)
  right(90)
  forward(5)
  left(90)
  pendown()
  # Kommen noch weitere Schachteldreiecke?
  if Seitenlänge-20 > 40:
  # 3. Falls ja: Weitermachen mit nächst-kleinerem Schachteldreieck
    Schachteldreieck(Seitenlänge - 20)
  # 4. Falls nicht: Aufhören mit dem allerkleinsten Dreieck
  else:
    Vieleck(3,Seitenlänge - 20)


def Schachtelfünfeck(Seitenlänge):
  # 1. Male das äußerste Fünfeck
  Vieleck(5,Seitenlänge)
  # 2. Nimm Position für das nächstinnere Fünfeck ein
  penup()
  forward(10)
  right(90)
  forward(5)
  left(90)
  pendown()
  # Kommen noch weitere Schachtelfünfecke?
  if Seitenlänge-20 > 40:
  # 3. Falls ja: Weitermachen mit nächst-kleinerem Schachteldreieck
    Schachtelfünfeck(Seitenlänge - 20)
  # 4. Falls nicht: Aufhören mit dem allerkleinsten Dreieck
  else:
    Vieleck(5,Seitenlänge - 20)


def Schachtelkreis(Seitenlänge):
  # 1. Male den äußersten Kreis (= Vieleck mit 50 Ecken)
  Vieleck(50,Seitenlänge)
  # 2. Nimm Position für den nächstinneren Kreis ein
  penup()
  forward(10)
  right(90)
  forward(6)
  left(90)
  pendown()
  # Kommen noch weitere Schachtelkreise?
  if Seitenlänge-2 > 2:
  # 3. Falls ja: Weitermachen mit nächst-kleinerem Schachtelkreis
    Schachtelkreis(Seitenlänge - 2)
  # 4. Falls nicht: Aufhören mit dem allerkleinsten Kreis
  else:
    Vieleck(50,Seitenlänge - 2)

def Schachtelellipse(Schritte):
  # 1. Male aktuelle Ellipse
  Ellipse(Schritte)
  # 2. Nimm Position für die nächstinnere Ellipse ein
  penup()
  forward(10)
  right(90)
  forward(10)
  left(90)
  pendown()
  # Kommen noch weitere Schachtelellipsen?
  if Schritte-1 > 1:
  # 3. Falls ja: Weitermachen mit nächstkleinerer Schachtelellipse
    Schachtelellipse(Schritte - 1)
  # 4. Falls nicht: Aufhören mit der allerkleinster Ellipse
  else:
    Ellipse(Schritte - 1)
    

def Schachtelfünfzackenstern(Seitenlänge):
  # 1. Male den äußersten Fünfzackenstern
  Fünfzackenstern(Seitenlänge)
  # 2. Nimm Position für den nächstinneren Fünfzackenstern ein
  penup()
  forward(20)
  right(90)
  forward(6)
  left(90)
  pendown()
  # Kommen noch weitere Schachtelfünfzackensterne?
  if Seitenlänge-40 > 20:
  # 3. Falls ja: Weitermachen mit nächst-kleinerem Schachtelfünfzackenstern
    Schachtelfünfzackenstern(Seitenlänge - 40)
  # 4. Falls nicht: Aufhören mit dem allerkleinsten Fünfzackenstern
  else:
    Fünfzackenstern(Seitenlänge - 40)
  
# Hier kommen die Funktionsaufrufe

#Schachtelquadrat(240)
#Schachteldreieck(240)
#Schachtelfünfeck(240)
#Schachtelkreis(24)
Schachtelfünfzackenstern(300)
#Schachtelellipse(8)

hideturtle()
exitonclick()
 




