# Unterschiedliche verschachtelte Figuren mit while-Schleifen
# Name: SchachtelfigurenMitSchleifen.py

from turtle import *
from random import *

shape("turtle")
speed(0)


### HILFSFIGUREN

def Quadrat(Seitenlänge):
  color(random(),random(),random())
  begin_fill()
  for i in range(4):
    forward(Seitenlänge)
    right(90)
  end_fill()

def Vieleck(Ecken,Seitenlänge):
  color(random(),random(),random())
  begin_fill()
  for i in range (Ecken):
    forward(Seitenlänge)
    right(360/Ecken)
  end_fill()

def Fünfzackenstern(Schritte):
  color(random(),random(),random())
  begin_fill()
  for i in range(5):
    forward(Schritte)
    right(2 * 360/5)
  end_fill()


### SCHACHTELFIGUREN 
  
def Schachtelquadrat(Seitenlänge):
  while Seitenlänge >= 20:
    # 1. Male das äußerste Quadrat
    Quadrat(Seitenlänge)
    # 2. Nimm Position für das nächstinnere Quadrat ein
    penup()
    forward(10)
    right(90)
    forward(10)
    left(90)
    pendown()
    # Seitenlänge verkleinern
    Seitenlänge = Seitenlänge - 20
    

def Schachteldreieck(Seitenlänge):
  while Seitenlänge >= 20:
    # 1. Male das äußerste Dreieck
    Vieleck(3,Seitenlänge)
    # 2. Nimm Position für das nächstinnere Dreieck ein
    penup()
    forward(10)
    right(90)
    forward(5)
    left(90)
    pendown()
    # Seitenlänge verkleinern
    Seitenlänge = Seitenlänge - 20


def Schachtelfünfeck(Seitenlänge):
  while Seitenlänge >= 20:
    # 1. Male das äußerste Fünfeck
    Vieleck(5,Seitenlänge)
    # 2. Nimm Position für das nächstinnere Fünfeck ein
    penup()
    forward(10)
    right(90)
    forward(5)
    left(90)
    pendown()
    # Seitenlänge verkleinern
    Seitenlänge = Seitenlänge - 20


def Schachtelkreis(Seitenlänge):
  while Seitenlänge >= 2:
    # 1. Male den äußersten Kreis (= Vieleck mit 50 Ecken)
    Vieleck(50,Seitenlänge)
    # 2. Nimm Position für den nächstinneren Kreis ein
    penup()
    forward(10)
    right(90)
    forward(6)
    left(90)
    pendown()
    # Seitenlänge verkleinern
    Seitenlänge = Seitenlänge - 20


def BunterVogel(Seitenlänge):
  while Seitenlänge >= 20:
    # 1. Male den äußersten Fünfstern
    Fünfzackenstern(Seitenlänge)
    # 2. Nimm Position für den nächstinneren Fünfstern ein
    penup()
    forward(20)
    right(90)
    forward(6)
    left(90)
    pendown()
    # Seitenlänge verkleinern
    Seitenlänge = Seitenlänge - 20


# Programm beginnt
penup()
setpos(0, 200)
pendown()

# Hier kommen die Funktionsaufrufe

#Schachtelquadrat(240)
#Schachteldreieck(240)
#Schachtelfünfeck(240)
#Schachtelkreis(24)
BunterVogel(300)

exitonclick()
 




