from turtle import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Snake - Das Spiel!") # Titelzeile
    Spielfeld.bgcolor("lightgreen")       # Hintergrundfarbe
    Spielfeld.setup(Breite, Hoehe)        # Größe

def initSchlange():
    Snake.speed(1)           # Die Schlange ist langsam,
    Snake.shape("circle")    # der Kopf ist ein Kreis
    Snake.color("black")     # und schwarz.
    Snake.richtung = "keine" # Sie hat zunächst keine Richtung,
    Snake.penup()            # sie hinterlässt keine Spur,
    Snake.goto(0, 100)       # und sie startet hier.

def initRichtung():
    Spielfeld.listen() # das Spielfeld lauscht auf die Tasten
    Spielfeld.onkey(gehe_hoch,   "Up")
    Spielfeld.onkey(gehe_runter, "Down")
    Spielfeld.onkey(gehe_rechts, "Right")
    Spielfeld.onkey(gehe_links,  "Left")
    Spielfeld.onkey(stoppe,      "space")
    
def gehe_hoch():
        Snake.richtung = "hoch"
def gehe_runter():
        Snake.richtung = "runter"
def gehe_rechts():
        Snake.richtung = "rechts"
def gehe_links():
        Snake.richtung = "links"       
def stoppe():
        Snake.richtung = "keine"

def bewegeSchlange():
    x = Snake.xcor()               # (x,y): Position der Schlange          
    y = Snake.ycor()
    if Snake.richtung == "hoch":   # Gehe 20 Pixel nach oben
        Snake.sety(y+20)  
    if Snake.richtung == "runter": # Gehe 20 Pixel nach unten
        Snake.sety(y-20)  
    if Snake.richtung == "rechts": # Gehe 20 Pixel nach rechts
        Snake.setx(x+20)  
    if Snake.richtung == "links":  # Gehe 20 Pixel nach links 
        Snake.setx(x-20)     

######## PROGRAMM:
        
Spielfeld = Screen()    # Spielfeld wird erzeugt.
Snake = Turtle()        # Schlange Snake wird erzeugt.
initSpielfeld(480, 480) # (Breite, Höhe)
initSchlange()          # Snake bekommt Anfangseigenschaften
initRichtung()          # Verbinde Richtungsfunktionen mit Tasten-Events
Spielfeld.update()

while True:
    bewegeSchlange()
    Spielfeld.update()

