# Mandala schwarz-weiß zum Ausmalen
# Name: Mandala.py

from turtle import*
shape ("turtle")
speed(0) # höchste Geschwindigkeit
width(2) # mitteldicke Linie

# Funktionen für verschiedene Figuren für Mandalas

def Raute(Schritte):   
  for i in range(2):
    forward(Schritte)
    left(36)
    forward(Schritte)
    left(144)
  
def Kreis(Schritte):
  for i in range (60):
    forward(Schritte)
    right(6)

def Dreieck(Schritte):   
  for i in range(3):
    forward(Schritte)
    left(120)

# Hier beginnt das Programm für ein Mandala

# Male 5 Kreise, im Kreis angeordnet
width(2)
for i in range(5):
    Kreis(20)
    left(72)

left(57) # Startposition für Rautenstern anpassen
    
# Male 10 Rauten im Kreis angeordnet
for i in range(10):
  Raute(200)
  left(36) 

# Male 10 kleine blaue Rauten im Kreis angeordnet, mit grün ausgefüllt
for i in range(10):
  Raute(50)
  left(36)

# Male 5 kleine Kreise zwischen die Rautenspitzen
for i in range(5):
  penup()
  forward(280)
  left(90)
  pendown()
  Kreis(4)
  penup()
  right(90)
  backward(280)
  left(72)

exitonclick()


