# Mandala aus Rauten, Kreisen und Dreiecken 
# Name: Mandala_ausgemalt.py

from turtle import*
shape ("turtle")
speed(0) # höchste Geschwindigkeit

# Funktionen für verschiedene Figuren

def Raute(Schritte):   
  for i in range(2):
    forward(Schritte)
    left(35)
    forward(Schritte)
    left(145)
  
def Dreieck(Schritte):   
  for i in range(3):
    forward(Schritte)
    left(120)

def Kreis(Schritte):
  for i in range (60):
    forward(Schritte)
    right(6)


# Hier beginnt das Programm für ein ausgemaltes Mandala

# Male 5 Kreise, im Kreis angeordnet, mit lila Farbe gefüllt
width(2)
color("violet")
begin_fill()
for i in range(5):
    Kreis(10)
    left(72)
end_fill()

left(56) # Startposition für Rauten anpassen
    
# Male 10 Rauten im Kreis angeordnet, mit blauer Farbe gefüllt
color("blue")
begin_fill()
for i in range(10):
  Raute(100)
  left(36) 
end_fill()

left(6) # Startposition für Dreicke anpassen

# Male 5 Dreiecke, im Kreis angeordnet, orangefarben ausgefüllt
color("orange") 
begin_fill()  
for i in range(5):  
  Dreieck(100)
  left(72)
end_fill()

left(-6) # Startposition für kleine Rauten anpassen

# Male 10 kleine blaue Rauten im Kreis angeordnet, mit grün ausgefüllt
for i in range(10):
  color("blue")
  begin_fill()
  Raute(50)
  color("lightgreen")
  end_fill()
  left(36) 

left(15) # Startposition für blaue Kreise anpassen

# Male 5 Kreise, blauer Rand, unausgefüllt
width(3)
color("blue")
for i in range(5):
    Kreis(10)
    left(72)


exitonclick()


