# Die Schildkröte läuft in Schlangenlinien nach rechts bis zum Fensterrand,
# dann kehrt sie um und läuft wieder zurück zu dem Startpunkt.
# Wir machen das mit zwei while-Schleifen:
# erste while-Schleife - bis zum Fensterrand,
# zweite while-Schleife - vom Fensterrand wieder nach Hause.
# Die Rand-Bedingung ist in eine bedingte Abfrage eingebaut.
#
# Name: Schlangenlinien.py

from turtle import *

shape("turtle")
color("green")
turtlesize(2)
width(2)
speed(0)

Ecken = 50
Halbkreis = 25

#Startausrichtung 90 Grad
left(90)

# Testvariable wird auf True gesetzt
lauf = True

while lauf :
    print("ich laufe nach rechts")
    # erster Halbkreis
    for i in range (Halbkreis):
        forward(3)
        right(360/Ecken)

    # zweiter Halbkreis
    for i in range (Halbkreis):
        forward(3)
        left(360/Ecken)

    # eine ganze Schlangenlinie gemacht;
    # jetzt prüfe den rechten Fensterrand:
    # weil von der Mitte gestartet wurde,
    # nimm die halbe Fensterbreite und ziehe noch 100 Pixel ab,
    # damit die Schildkröte nicht hinterm Rand verschwindet 
    if xcor() >= window_width()/2 - 100 :
        print("habe den rechten Rand erreicht")
        # Abbruch 
        lauf = False
        #print("X:", xcor(), "Rand:", window_width()/2 - 100)
        

print("ich kehre um")
# eine Drehung um 180 Grad
left(180)
     
# Abbruchvariable wird wieder auf True gesetzt
lauf = True
   
while lauf :
    print("und laufe zurück") 
    # erster Halbkreis
    for i in range (Halbkreis):
        forward(3)
        right(360/Ecken)

    # zweiter Halbkreis
    for i in range (Halbkreis):
        forward(3)
        left(360/Ecken)

     
    # prüfe, ob Zuhauze erreicht ist (das Zuhause ist 20 Pixel groß)
    if xcor() <= 20 :
        color("yellow")
        home()
        print("Juchuu! Bin endlich wieder zu Hause!")
        # Abbruch
        lauf = False

              
exitonclick()



