# Male farbige Vielecke 
# Funktion Vieleck hat Parameter:
#   - Breite - die Pinselbreite,
#   - Ecken - die Anzahl der Ecken,
#   - Schritte - die Pixelanzahl für die Schritte.
# Farbe und Position sind zufällig gewählt.
# 
# Name: Vielecke_Zufallsposition_und_farbe

from random import *
from turtle import *
shape("turtle")
speed(0)

def Vieleck(Ecken, Schritte):
    for i in range(Ecken):
        forward(Schritte)
        right(360/Ecken)

def Zufallsvieleck(Ecken, Breite, Schritte):
    # a. Positioniere Schildkröte auf Zufallsposition
    x = randint(-250, 250)
    y = randint(-150, 150)
    penup()
    setpos(x,y)
    pendown()

    # b. setze Zufallsfarbe
    rot = random()
    gruen = random()
    blau = random()    
    color(rot, gruen, blau)

    # c. setze Linienbreite
    width(Breite)

    # d. Bestimme zufällig, ob Vieleck gefüllt werden soll oder nicht
    GefuelltOderNicht = randint(0, 1) # 1: JA, 0: NEIN
    
    # e. Bedingte Anweisung: Soll Vieleck gefüllt werden?
    if GefuelltOderNicht == 1 :
        # Falls ja: Male gefülltes Vieleck
        begin_fill()
        Vieleck(Ecken, Schritte)
        end_fill()
        # Falls nein: Male Vieleck ohne Füllung
    else :
        Vieleck(Ecken, Schritte)

        
########### Programm beginnt

for i in range(10) :
    # Male einige Vielecke unterschiedlicher Art und Größe
    # durch Aufruf von Zufallsvieleck(Ecken, Breite, Schritte)

    # ENTWEDER: Parameter sind von dir bestimmte Werte:
    Zufallsvieleck(3, 6, 40)
    Zufallsvieleck(6, 3, 40)
    Zufallsvieleck(8, 3, 55)
    Zufallsvieleck(12, 2, 20)
    Zufallsvieleck(4, 6, 60)
    Zufallsvieleck(20, 3, 10)

##    # ODER: Alle Parameter sind Zufallszahlen:
##    Ecken = randint(3,8)      # Figuren zwischen Dreieck und Achteck
##    Breite = randint(1,6)     # Breite zwischen 1 und 6
##    Schritte = randint(10,80) # Schrittweite zwischen 10 und 80 Pixeln
##    Zufallsvieleck(Ecken, Breite, Schritte)

exitonclick()

