from turtle import *

speed(0)
shape("turtle")

###################  KARDIOIDE:
## Bewegen sich zwei punktförmige Körper mit konstanter Geschwindigkeit auf einem
## Kreis derart, dass der eine doppelt so schnell ist wie der andere, so umhüllt die
## Verbindungsgerade ihrer Positionenen eine sogenannte Kardioide (von lat.: Herz).

def Vieleck_mit_Liste(Ecken,Schritte):
    global Eckenliste
    Winkel = 360/Ecken
    for i in range(Ecken):
        forward(Schritte)
        Eckenliste.append([xcor(),ycor()])
        left(Winkel)

def erzeuge_ZweiteListe():     # 2-fache Geschw.
    global ZweiteListe
    Ecken = len(Eckenliste)
    for i in range(Ecken):
        ZweiteListe.append(Eckenliste[(2*i) % Ecken])
    
#def erzeuge_ZweiteListe(multi): # multi-fache Geschw.
#    global ZweiteListe
#    Ecken = len(Eckenliste)
#    for i in range(Ecken):
#        ZweiteListe.append(Eckenliste[(multi*i) % Ecken])

        
def zeichneDiagonalen():
    for i in range(len(Eckenliste)):
        aktuelleEcke = Eckenliste[i]  # aktuelle Ecke: Koordinaten lesen
        aE_x = aktuelleEcke[0]
        aE_y = aktuelleEcke[1]
        goto(aE_x,aE_y)               # setze dich in aktuelle Ecke
        
        zweiteEcke = ZweiteListe[i]   # zweite Ecke: Koordinaten lesen
        zE_x = zweiteEcke[0]
        zE_y = zweiteEcke[1]
        goto(zE_x,zE_y)               # verbinde aktuelle mit zweiter Ecke
        goto(aE_x,aE_y)               # zurück zur aktuellen Ecke
        

####### PROGRAMM

## VARIABLEN
Eckenliste = []
ZweiteListe = []

## Verschiebe Anfangsposition nach unten
penup()
setpos(0,-300)
pendown()

Vieleck_mit_Liste(150, 10)  # (Ecken, Schritte)
erzeuge_ZweiteListe()
#erzeuge_ZweiteListe(3)     # (Multiplikator)
zeichneDiagonalen()


