# Fünfzackiger Stern und Sterne mit beliebig vielen Zacken
# Name: Sterne.py

from turtle import *
shape("turtle")
width(2)
speed(0)

# Hier der Fünfzackenstern aus 5 Linien gemalt
def Fuenfzackenstern(Farbe,Schritte):
        color(Farbe)
        begin_fill()
        for i in range(5):
                forward(Schritte)
                right(2 * 360/5)
        end_fill()


##Erklärung des Drehwinkels 2 * 360/5:
##        - Fünfeck, wo auf jeder Seite ein gleichschenkliges Dreieck thront
##        - Die beiden gleichen Dreieckswinkel entsprechen dem Drehwinkel vom Fünfeck
##        - Das sind 360/5 = 72 Grad
##        - Damit ist der spitze Winkel 180 - (2*72) = 36 Grad
##        - Damit ist der Drehwinkel der Schildkröte 180-36 = 144 Grad
##        - Also: 180 - (180 - (2* 360/5))


# Hier geht die Schildkröte am Zackenrand entlang
def Vielzackenstern(Zacken,Farbe,Schritte):
        color(Farbe)
        begin_fill()
        for i in range(Zacken):
                forward(Schritte)
                right(2 * 360/Zacken)
                forward(Schritte)
                left(360/Zacken)
        end_fill()

        
# Programm beginnt --------------------------------------

#Fuenfstern("gold", 260)     
Vielzackenstern(5,"red",100)
back(32)
left(32)
Vielzackenstern(5,"green",100)

hideturtle()
exitonclick()
