# Malt einen Baum mit rekursiven Astgabeln
#   - Winkel: Winkel der Astgabelung
#   - Astlänge: Länge eines Astes (wird nach oben hin kürzer)
#   - Astdicke: Dicke eines Astes (wird nach oben hin dünner)
#
# Name: Baum.py

from turtle import *
shape("turtle")
width(2)
color("darkgreen")
  
def Baum(Winkel, Astlänge, Astdicke, RT):
    # 1. Male einen Ast (den Stamm der Gabelung)
    width(Astdicke)
    forward(Astlänge)
    # 2. Male die Astgabelung: Rufe zweimal Baum auf
    if RT > 0:
        left(Winkel)
        # linker Teil der Gabelung
        Baum(Winkel, 0.8*Astlänge, 0.7*Astdicke, RT-1)
        backward(0.8*Astlänge)
        
        right(Winkel*2)
        # rechter Teil der Gabelung
        Baum(Winkel, 0.8*Astlänge, 0.7*Astdicke, RT-1)
        backward(0.8*Astlänge)
        
        left(Winkel)
    else:
   # 3. Male die letzte Astgabelung an der Spitze
        left(Winkel)
        forward(0.8*Astlänge)
        backward(0.8*Astlänge)
        right(Winkel*2)
        forward(0.8*Astlänge)
        backward(0.8*Astlänge)
        left(Winkel)
 

# Programm beginnt ---------------------------------
penup()
left(90)      # Drehe Schildkröte nach oben
backward(200) # Fange ganz unten an
pendown()

Winkel=20
Astlänge=80
Astdicke=10
RT=4
Baum(Winkel,Astlänge,Astdicke,RT)

exitonclick()
