# Schachbrett(Felderzahl, Feldlänge, GefülltOderNicht):
# Malt ein Schachbrett mit
# - Felderzahl: Zahl der Felder pro Reihe und Spalte
# - Feldlänge: Zahl der Pixelschritte für eine Feldseite
# - GefülltOderNicht: Wenn 1, dann Feld gefüllt; wenn -1, dann nicht
#
# Name: Schachbrett.py

from turtle import *
speed(0)
shape("turtle")
color("black")


def Feld(Feldlänge,GefülltOderNicht):
    if GefülltOderNicht == 1:     
        begin_fill()  
    for i in range(4):
        forward(Feldlänge)
        left(90)
    if GefülltOderNicht == 1:
        end_fill()
                
  
def Felderecke(Felderzahl, Feldlänge, GefülltOderNicht):
    # Male aktuelle waagerechte Reihe oben
    for i in range(Felderzahl) :   
        Feld(Feldlänge,GefülltOderNicht)
        forward(Feldlänge)
        GefülltOderNicht = GefülltOderNicht*(-1)  # nächstes Feld andersfarbig

    backward(Feldlänge) 
    right(90) # drehe dich nach rechts unten
    
    # Male aktuelle senkrechte Reihe rechts
    for i in range(Felderzahl-1) :  
        Feld(Feldlänge,GefülltOderNicht)
        forward(Feldlänge)
        GefülltOderNicht = GefülltOderNicht*(-1)  # nächstes Feld andersfarbig


def SchachbrettAlsRekursion(Felderzahl, Feldlänge, GefülltOderNicht):
    x = xcor()  # Hier ist die Schildkröte
    y = ycor()
    if Felderzahl > 0 :
        # Male aktuelle Felderecke
        Felderecke(Felderzahl, Feldlänge, GefülltOderNicht)

        # Gehe zum Beginn der nächstinneren Felderecke
        penup()
        setpos(x, y-Feldlänge)
        setheading(0)
        pendown()

        # Male nächstinneres Schachbrett
        SchachbrettAlsRekursion(Felderzahl-1, Feldlänge, GefülltOderNicht*(-1))
        
def SchachbrettAlsSchleife(Felderzahl, Feldlänge, GefülltOderNicht):
    for i in range(Felderzahl): # Male 8 Zeilen
        x = xcor()
        y = ycor()
        # In jeder Zeile: Male 8 Felder nebeneinander
        for i in range(Felderzahl): 
            Feld(Feldlänge,GefülltOderNicht)
            forward(Feldlänge)
            GefülltOderNicht = GefülltOderNicht*(-1)#nächstes Feld andersfarbig

        # Gehe zum Beginn der nächsten Zeile
        penup()
        setpos(x, y-Feldlänge)
        setheading(0)
        pendown()
        GefülltOderNicht = GefülltOderNicht*(-1) #nächstes Feld andersfarbig

        
####### HIER BEGINNT DAS PROGRAMM:

Felderzahl=8
Feldlänge=40

SchachbrettAlsRekursion(Felderzahl, Feldlänge, 1)
#SchachbrettAlsSchleife(Felderzahl, Feldlänge, 1)

exitonclick()
