# Baum(Winkel, Astlänge, RT, Blattgröße, Blattfarbe) malt einen Baum
# Das Programm kombiniert mehrere verschiedene Bäume zu einem Wald.
#
# Name: Wald.py ##############################

from turtle import *

shape("turtle")
width(2)
color("darkgreen")

  
def Baum(Winkel, Astlänge, Astdicke, RT, Blattgröße, Blattfarbe):
    # 1. Male einen Ast (den Stamm der Gabelung)
    width(Astdicke)
    forward(Astlänge)
    # 2. Male die Gabelung: Rufe zweimal Baum auf
    if RT > 0:
        left(Winkel)
        Baum(Winkel, 0.8*Astlänge, 0.7*Astdicke, RT-1, Blattgröße, Blattfarbe)
        
        backward(0.8*Astlänge)
        
        right(Winkel*2)
        Baum(Winkel, 0.8*Astlänge, 0.7*Astdicke, RT-1, Blattgröße, Blattfarbe)

        backward(0.8*Astlänge)
        left(Winkel)
    else:
   # 3. male die letzte Astgabelung an der Spitze
 
        left(Winkel)
        forward(0.8*Astlänge)
        color(Blattfarbe)
        dot(Blattgröße) 
        penup()
        backward(0.8*Astlänge)
        right(Winkel*2)
        pendown()
        color("darkgreen")
        forward(0.8*Astlänge)
        color(Blattfarbe)
        dot(Blattgröße+3)
        color("darkgreen")
        penup()
        backward(0.8*Astlänge)
        left(Winkel)
        pendown()
 

# Programm beginnt
# bgcolor("lightgreen") # Hintergrundfarbe

# Male verschiedene Bäume an verschiedenen Positionen
# Rufe auf: Baum(Winkel, Astlänge, Astdicke, RT, Blattgröße, Blattfarbe)

penup()
home()
left(90)
setpos(-200,0)
pendown()
Baum(30,40,10,4,8,"red")

penup()
home()
left(90)
setpos(100,-50)
pendown()
Baum(35,60,15,5,20,"pink")

penup()
home()
left(90)
setpos(-100,-100)
pendown()
Baum(35,50,12,4,10,"magenta")

penup()
home()
left(90)
setpos(-50,100)
pendown()
Baum(25,50,10,3,15,"orange")


penup()
home()
left(90)
setpos(150,-150)
pendown()
Baum(30,40,12,4,15,"yellow")

    

exitonclick()



