from turtle import *

def initSpielfeld(Breite, Hoehe):         
    Spielfeld.title("Parkour - Das Spiel!")    # Titel
    Spielfeld.bgcolor("lightyellow")   # Hintergrundfarbe
    Spielfeld.setup(Breite, Hoehe)     # Größe
    color("green", "lightgreen")       # Malfarbe und Füllfarbe
    shape("circle")                    # kreisförmiger Pinsel
    legeFliese(0,0)                    # 1. Fliese in der Mitte


def initKroete():
    Kroetchen.speed(1)            # Sie ist langsam,
    Kroetchen.showturtle()        # und ist jetzt sichtbar,
    Kroetchen.shape("turtle")     # hat Schildkrötenform
    Kroetchen.color("brown")      # und ist braun
    Kroetchen.shapesize(1.5, 1.5) # und größer als normal.
    Kroetchen.penup()             # Sie hinterlässt keine Spur
    Kroetchen.home()

def legeFliese(x, y):   
  # gehe in die linke untere Fliesenecke: 
    penup()
    goto(x-Fliesenseite/2, y-Fliesenseite/2)
    
  # male das gefüllte Fliesenquadrat:
    pendown()            
    begin_fill()
    Quadrat(Fliesenseite)
    end_fill()
    
  # gehe wieder zur Mitte:
    penup()
    goto(x, y)

def Quadrat(Seite):
    for i in range(4):
        forward(Seite)
        left(90)

def aktiviereTasten():
    Spielfeld.listen()   # das Spielfeld lauscht auf die Pfeiltasten
    Spielfeld.onkey(gehe_hoch,   "Up")
    Spielfeld.onkey(gehe_runter, "Down")
    Spielfeld.onkey(gehe_rechts, "Right")
    Spielfeld.onkey(gehe_links,  "Left")
 
def gehe_hoch():
     legeFliese(xcor(), ycor() + Fliesenseite)
     Wegstrecke.append([xcor(), ycor(), 90])
     #print("Wegstrecke", Wegstrecke)
     
def gehe_runter():
     legeFliese(xcor(),ycor() - Fliesenseite)
     Wegstrecke.append([xcor(), ycor(), 270])
     #print("Wegstrecke", Wegstrecke)
     
def gehe_rechts():
     legeFliese(xcor() + Fliesenseite, ycor())
     Wegstrecke.append([xcor(), ycor(), 0])
     #print("Wegstrecke", Wegstrecke)
     
def gehe_links():
     legeFliese(xcor() - Fliesenseite, ycor())
     Wegstrecke.append([xcor(), ycor(), 180])
     #print("Wegstrecke", Wegstrecke)


########################
        
## OBJEKTE UND SPIELEINSTELLUNGEN
Spielfeld = Screen()
Kroetchen = Turtle()
tracer(0)              # Turbo-Modus: Bild neu erst bei update()

## VARIABLEN
Breite = 600           # Breite des Spielfeldes
Hoehe  = 600           # Höhe des Spielfeldes
Fliesenseite = 40      # Größe eines Fliesenquadrats
Wegstrecke = []        # Liste der Fliesen auf dem Weg

## INITIALISIERUNGEN
initSpielfeld(Breite, Hoehe)
initKroete()

## PROGRAMM
aktiviereTasten()      # Bei Pfeiltasten: Fliesenlegen
                       #   bei Leertaste: Parkourlauf
while True:
    Spielfeld.update() # Zeige Spielfeld und lausche auf Tasten



    



