# Animationen.py
# Hier werden dreidimensionale Bewegungen vorgetäuscht.

from turtle import *

shape("circle")

def erzeugeHerzform():
    speed(0)
    hideturtle()
    penup()
    
    begin_poly()
    unten = position()
    setheading(120) 
    forward(25)         # linke Seite
    setheading(90)
    for i in range(21): # linker Halbkreis
        forward(1)
        right(9)
    Mitte = position()
    setheading(90)
    for i in range(21): # rechter Halbkreis
        forward(1)
        right(9)
    goto(unten)         # rechte Seite
    setheading(90)      # am Ende nach oben gucken
    end_poly()
    
    register_shape("Herz", get_poly())
    shape("Herz")
    pendown()
    showturtle()

     
def DrehendeScheibe():
    pensize(8)	        # Stab als graue, fette Linie
    color("black") 	
    penup()
    goto(-150, 0)	
    pendown()
    forward(300)	
    
    goto(0, 0)	        # Scheibe als grüne Ellipse
    color("green")
    left(90)            # "Blickrichtung" der Scheibe: nach oben

    
    while(True):
        for i in range(10,0,-1):
            shapesize(10, i)	# Höhe der Ellipse schrumpft
            #left(18)
        for i in range(10):
            shapesize(10, i+1)	# Höhe der Ellipse wächst
            #left(18)

def SchlagendesHerz():
    color("red")
    erzeugeHerzform()   # auskommentieren für kreisförmiges Herz
    speed(1)
    penup()
    while(True):
        for i in range(9,0,-1):
            shapesize(i, i)	   # Höhe und Breite schrumpfen
            goto(xcor(),ycor()+i)  # Herzspitze verschiebt sich nach oben
            goto(xcor(),ycor()+i)  # nochmal nach oben
        for i in range(10):
            shapesize(i+1, i+1)	   # Höhe und Breite wachsen
            goto(xcor(),ycor()-i)  # Herzspitze verschiebt sich nach unten
            goto(xcor(),ycor()-i)  # nochmal nach unten
 
def SpringenderBall():
    penup()
    goto(-150, -200) # der Boden: fette graue Linie
    pensize(40)
    color("gray")
    pendown()
    forward(300)

    penup()          # der Ball: rote Circle-Schildkröte
    shape("circle")
    color("red")
    shapesize(5, 5)
    goto(0, 100)     

    Fallhoehe = 60    # wird bei jedem Hüpfer etwas weniger      
    while (Fallhoehe > 0):   
        for i in range(4):        # Ball fällt runter
            sety(ycor() - Fallhoehe)
        for i in range(5,0,-1):   # Bodenkontakt:
            shapesize(i, 5)	    # Höhe der Ellipse schrumpft
            sety(ycor() - 5)
        for i in range(5):
            shapesize(i+1, 5)	    # Höhe der Ellipse wächst
            sety(ycor() + 5)
        Fallhoehe = Fallhoehe - 5
        for i in range(4):        # Ball fliegt hoch
            sety(ycor() + Fallhoehe)
        
 

##### PROGRAMM BEGINNT

#speed(0)
DrehendeScheibe()

#SchlagendesHerz()

#speed(2)
#SpringenderBall()

            

