# Tisch.py
# malt kreis-basierte Zylinder (Tischbeine)
# und rechteck-basierte Quader (Tischplatte)
# - Schritte: Größe der Querschnittsfigur
# - Anzahl: Anzahl der aufeinanderliegenden Figuren

from turtle import *


shape("turtle")
#speed(0)
tracer(0)

## QUERSCHNITTS-FIGUREN ##

def Vieleck(Schritte,Ecken):
    for i in range(Ecken):
        forward(Schritte)
        left(360/Ecken)

def Kreis(Schritte):
    Vieleck(Schritte,36)
     
def Kreis_gefüllt(Schritte):
    color("orange")
    begin_fill()
    Vieleck(Schritte,36)
    end_fill()

def Rechteck(Breite,Hoehe):
    for i in range(2):
        forward(Breite)
        left(90)
        forward(Hoehe)
        left(90)

        
## 3D-KÖRPER ##
        
def Zylinder(Schritte,Anzahl):
    for i in range(Anzahl):
        Kreis(Schritte)
        left(90)
        forward(5)
        right(90)
        
def Quader_perspektivisch(Breite, Hoehe, Anzahl):
    for i in range(Anzahl):
        Rechteck(Breite,Hoehe)
        left(90)
        forward(5)
        right(90)
        forward(5)
        Breite = Breite-2   



##### PROGRAMM BEGINNT


## rechteckiger Tisch mit vier runden Beinen
Tischbreite = 200
TischHoehe =20

color("brown")
penup()
home()           # 1.  Tischbein links vorne
sety(ycor()-120)
pendown()
Zylinder(2,25) 
penup()

home()           # 2.  Tischbein links hinten
sety(ycor()-100)
setx(xcor()+80)
sety(ycor()+80)
pendown()
Zylinder(2,20)

penup()
sety(ycor()-100) # 3.  Tischbein rechts hinten
setx(xcor()+ Tischbreite - 42)
pendown()
Zylinder(2,20)

penup()
home()           # 4.  Tischbein rechts vorne
sety(ycor()-120) 
setx(xcor()+ Tischbreite)
pendown()
Zylinder(2,25)

penup()          # Tischplatte
home()
pendown()
color("blue")
width(2)
Quader_perspektivisch(Tischbreite,TischHoehe,16)


hideturtle()
update()




    

