#Tunnel.py
#zeichnet Drahtgittermodelle von 3D-Tunneln verschiedener Formen
# - Tunneleingang hat die Form von Vieleck(Schritte,Ecken)

from turtle import *

shape("turtle")
#speed(0)
tracer(0)

def Vieleck(Schritte,Ecken):
    for i in range(Ecken):
        forward(Schritte)
        left(360/Ecken)

def Tunnel(Schritte,Ecken):
    for i in range(20):
        Vieleck(Schritte,Ecken)
        forward(4) 
        left(90)
        forward(4) 
        right(90)

def Tunnel_perspektivisch(Schritte,Ecken):
    for i in range(35):
        Vieleck(Schritte,Ecken)
        forward(6) 
        left(90)
        forward(6) 
        right(90)
        Schritte = Schritte - 1
        
def Tunnel_aufwärtsgekrümmt(Schritte,Ecken,Richtung):
    aufwärts = Richtung
    seitwärts = Richtung
    for i in range(44):
        Vieleck(Schritte,Ecken)
        forward(seitwärts) 
        left(90)
        forward(aufwärts) 
        right(90)
        Schritte = Schritte - 1
        aufwärts = aufwärts +1
        #seitwärts = seitwärts - 0.5
        
        
def Tunnel_linksgekrümmt(Schritte,Ecken,Richtung):
    aufwärts = Richtung
    seitwärts = Richtung
    for i in range(40):
        Vieleck(Schritte,Ecken)
        forward(seitwärts) 
        left(90)
        forward(aufwärts) 
        right(90)
        Schritte = Schritte - 1
        #aufwärts = aufwärts 
        seitwärts = seitwärts - 0.5
        left(1)
       
def Tunnel_rechtsgekrümmt(Schritte,Ecken,Richtung):
    aufwärts = Richtung
    seitwärts = Richtung
    for i in range(30):
        Vieleck(Schritte,Ecken)
        forward(seitwärts) 
        left(90)
        forward(aufwärts) 
        right(90)
        Schritte = Schritte - 1
        #aufwärts = aufwärts 
        seitwärts = seitwärts + 0.5
        right(1)    

        
###### PROGRAMM BEGINNT

penup()
goto(-200,-200)  # Anfangsposition unten links
pendown()

#Tunnel(100,8)
Tunnel_perspektivisch(50,25)
#Tunnel_aufwärtsgekrümmt(100,8,5)  # (Schritte,Ecken,Richtung)
#Tunnel_linksgekrümmt(100,8,5)


##### Schwarzer quadratischer Tunnel mit 2 bunten Abzweigungen:
##
##Tunnel_perspektivisch(140,4)
##Tunnel1ende=pos()   # merke dir das Ende von Tunnel1
##color("green")
##Tunnel_linksgekrümmt(100,4,5)
##penup()
##setpos(Tunnel1ende) # zurück zum Ende von Tunnel 1
##setheading(0)
##pendown()
##color("red")
##Tunnel_rechtsgekrümmt(100,4,5)


